#!/usr/bin/env python

import sys
import memory.opsinsight_memory
import ops_io.opsinsight_io
import cpu.opsinsight_cpu
import cache.opsinsight_cache
import builtins
 
import public.opstools
setattr(builtins, 'find_file', public.opstools.find_file)
setattr(builtins, "format_number", public.opstools.format_number)
setattr(builtins, "find_ops_cfgname", public.opstools.find_ops_cfgname)

ops_components = {
    "cpu": [(cpu.opsinsight_cpu)],
    "cache": [(cache.opsinsight_cache)],
    "mem": [(memory.opsinsight_memory)],
    "io": [(ops_io.opsinsight_io)]
}

class opsinsight():
    def __init__(self):
        self.cur_module = None
        # 1. param check
        if len(sys.argv) >= 2:
            if self.find_module(sys.argv[1]):
                self.exec_module()
            else:
                self.Usage()
        else:
            self.Usage()

    def Usage(self):
        usage = "Usage:\n\topsinsight  "
        for k, v in ops_components.items():
            usage += k + "|"
        usage = usage[0:-1]
        usage += " -h"
        print(usage)

    def find_module(self, module_name=None):
        for k, v in ops_components.items():
            if module_name == k:
                self.cur_module = k
                return True
        return False

    def exec_module(self):
        ops_components[self.cur_module][0].execute(sys.argv[2:])
        pass


if __name__ == "__main__":
    a = opsinsight()
