import os
import sys
import traceback

#DEFAULT_C_PATH="/mnt/opsinsight"
DEFAULT_C_PATH="/usr/local/opsinsight-1.0/"
def find_file(path, filename):
    for root, dirs, files in os.walk(path):
        for file in files:
            if file == filename:
                return os.path.join(root, file)
    for root, dirs, files in os.walk(DEFAULT_C_PATH):
        for file in files:
            if file == filename:
                return os.path.join(root, file)

    return None


def format_number(i_d):
    try:
        # byte
        if i_d < int(1024):
            o_d = "%dB" % (i_d)
        # KB
        elif i_d < 0x100000:
            o_d = "%.2fK" % (i_d/1024.0)
        # MB
        elif i_d < 0x3f600000:
            o_d = "%.2fM" % (i_d/1024/1024.0)
        # GB
        else:
            o_d = '%.2fG' % (i_d/1024/1024/1024.0)
        return o_d
    except Exception as e:
        print(e)
        return "%dB--" % (i_d)

def find_ops_cfgname():
    try:
        CFG_NAME = "opsinsight.conf"
        filename1 = CFG_NAME
        filename2 = "/etc/" + CFG_NAME
        if os.path.exists(filename1):
            return filename1
        elif os.path.exists(filename2):
            return filename2
        return None                       
    except Exception as e:
        print(e)
        traceback.print_exc()
        return None                
